/* Include files */
#include <windows.h>
//#include <wingdi.h>
#include <winuser.h>
#include <stdio.h>
#include "resource.h"
#include "ultra64.h"
#define NoOfOpCodesListed	28
#define ScrollPC			(int)((PC - OldPC)>>2)

/* Windows global variables */
HINSTANCE hInst; // Current instance
LPCTSTR lpszAppName="Ultra64";
static HWND ROMNameHandle=NULL;
static HWND ManufacturerHandle=NULL;
MSG msg;
DWORD dwExitCode;
HMENU hMenu;
UINT uState;
HANDLE CPUThread;

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	/* WinMain local variables */
	HWND hWnd;
	WNDCLASSEX wc;

	wc.style=CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc=(WNDPROC)WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInstance;
	wc.hIcon=LoadIcon(hInstance, lpszAppName);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName=lpszAppName;
	wc.lpszClassName=lpszAppName;
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.hIconSm=LoadImage(hInstance, lpszAppName, IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

	if(!RegisterClassEx(&wc)) return (FALSE);

	hInst=hInstance;
	
	hWnd=CreateWindow(lpszAppName, 
					  lpszTitle, 
					  WS_OVERLAPPEDWINDOW | WS_MAXIMIZE,
					  CW_USEDEFAULT, 0, 
					  CW_USEDEFAULT, 0, 
					  NULL, NULL, hInstance, NULL);
	hDC=GetDC(hWnd);
	hWndMain=hWnd;
	//ShowWindow(hWnd, nCmdShow);
	ShowWindow(hWnd, SW_SHOWMAXIMIZED);
	UpdateWindow(hWnd);
	
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (msg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd,
						 UINT uMsg,
						 WPARAM wParam,
						 LPARAM lParam)
{
	hMenu = GetMenu(hWndMain);
	switch(uMsg)
	{
	case WM_CREATE:
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_IPS:
			START_TIME=GetTickCount()/1000;
			Counter=CP0[9];
			FINISH_TIME=0;
			while(FINISH_TIME-START_TIME != 1)
			{
				FINISH_TIME=GetTickCount()/1000;
			}
			ips=CP0[9]-Counter;
			
			sprintf(space, "%9d instructions per second. ", ips);
			TextOut(hDC, 0, 0, space, strlen(space));
			if(SHOW_IPS)
			{
				SHOW_IPS=FALSE;
			}
			else
			{
				SHOW_IPS=TRUE;
			
			}
			break;
		case IDM_CLOSE:
			strcpy(title, "Ultra 64");
			SetWindowText(hWndMain, title);
			for(z=0;z<32;z++)
			{
				GPR[z]=0;
				CP0[z]=0;
				FCR[z]=0;
				FPR[z]=0;
				FGR[z]=0;
			}
			PC=0;
			OldPC=0;
			strcpy(ROMName, "");
			DISPLAY_HEADER=FALSE;
			NOT_OPEN_ROM=TRUE;
			TerminateThread(CPUThread, FALSE);
			CloseHandle(RomHandle);
			break;
		case IDM_OPEN:
			OPENFILENAME OpenFileName;
			char szFileName[MAX_PATH];
			char szDirectory[255];

			memset(szFileName,0,sizeof(szFileName));
			memset (&OpenFileName, 0, sizeof(OpenFileName));

			OpenFileName.lStructSize  = sizeof(OpenFileName);
			OpenFileName.hwndOwner    = hWnd;
			OpenFileName.lpstrFilter  = "N64 roms (*.v64,*.bin,*.n64\0*.v64; *.bin; *.n64\0All files (*.*)\0*.*\0";
			OpenFileName.lpstrFile    = szFileName;
			OpenFileName.lpstrInitialDir    = szDirectory;
			OpenFileName.nMaxFile     = MAX_PATH;
			OpenFileName.Flags        = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
			if (GetOpenFileName (&OpenFileName)) {				
				InvalidateRect(hWnd,NULL,TRUE);	
				CloseHandle(RomHandle);
			}
			OpenRom(szFileName);
			
			break;
		case IDM_ROM:
			DialogBox(hInst,
					  "ROM",
					  hWnd,
					  (DLGPROC)ROM);
			break;
		case IDM_EXIT:
			CloseHandle(RomHandle);
			DestroyWindow(hWnd);
		case IDM_ABOUT:
			DialogBox(hInst,
					  "About",
					  hWnd,
					  (DLGPROC)About);
			break;
		case IDM_STOP:
			uState=GetMenuState(hMenu,IDM_STOP,MF_BYCOMMAND);
			if(uState & MFS_CHECKED)
			{
				CheckMenuItem(hMenu,IDM_STOP,MF_BYCOMMAND | MFS_UNCHECKED);
				STOP_OP=FALSE;
			}
			else
			{
				CheckMenuItem(hMenu,IDM_STOP,MF_BYCOMMAND | MFS_CHECKED);
				STOP_OP=TRUE;
			}
			break;
		case IDM_COUNT:
			uState=GetMenuState(hMenu,
									 IDM_COUNT,
									 MF_BYCOMMAND);
			if(uState & MFS_CHECKED)
			{
				CheckMenuItem(hMenu, 
							  IDM_COUNT,
							  MF_BYCOMMAND | MFS_UNCHECKED);
				SetWindowText(hWnd, title);
				SHOW=FALSE;
			}
			else
			{
				CheckMenuItem(hMenu, 
							  IDM_COUNT,
							  MF_BYCOMMAND | MFS_CHECKED);
				SHOW=TRUE;
			}
			break;
			case IDM_START:
			DISPLAY_HEADER=FALSE;
			N64isRunning=1;
			strcpy(title, "Ultra 64 - ");
			if(ROMName[0]=='\0')
			{
				strcat(title, szFileName);
			}
			else
			{
			strcat(title, ROMName);
			}
			strcat(title, " - Running");
			SetWindowText(hWnd, title);
			TerminateThread(CPUThread, FALSE);
			CPUThread=CreateThread(NULL,
							  0,
							  (LPTHREAD_START_ROUTINE)CPUEmu,
							  hList,
							  0,
							  &dwChildId);
			break;
			case IDM_CPU_HIGH:
			SetThreadPriority(CPUThread, THREAD_PRIORITY_HIGHEST);
			CheckMenuItem(hMenu, 
							  IDM_CPU_HIGH,
							  MF_BYCOMMAND | MFS_CHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_NORMAL,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_LOW,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			
			break;
		case IDM_CPU_NORMAL:
			SetThreadPriority(CPUThread, THREAD_PRIORITY_NORMAL);
			CheckMenuItem(hMenu, 
							  IDM_CPU_HIGH,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_NORMAL,
							  MF_BYCOMMAND | MFS_CHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_LOW,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			
			break;
		case IDM_CPU_LOW:
			SetThreadPriority(CPUThread, THREAD_PRIORITY_BELOW_NORMAL);
			CheckMenuItem(hMenu, 
							  IDM_CPU_HIGH,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_NORMAL,
							  MF_BYCOMMAND | MFS_UNCHECKED);
			CheckMenuItem(hMenu, 
							  IDM_CPU_LOW,
							  MF_BYCOMMAND | MFS_CHECKED);
			
			break;
		case IDM_PAUSE:
			N64isRunning=0;
			break;
		case IDM_CPU_REGS:
			N64isRunning=0;
			CreateDialog(hInst, "GPR_REGS", hWnd, (DLGPROC)GPR_REGS);
			break;
			case IDM_COMMANDS:
			N64isRunning=0;
			CreateDialog(hInst, "COMMANDS", hWnd, (DLGPROC)COMMANDS);
			break;
			case IDM_CP0_REGS:
			N64isRunning=0;
			CreateDialog(hInst, "CP0_REGS", hWnd, (DLGPROC)CP0_REGS);
			break;
			case IDM_FPR_REGS:
			N64isRunning=0;
			CreateDialog(hInst, "FPR_REGS", hWnd, (DLGPROC)FPR_REGS);
			break;
		case IDM_RESET:
			for(z=0;z<32;z++)
			{
				GPR[z]=0;
				CP0[z]=0;
				FCR[z]=0;
				FPR[z]=0;
				FGR[z]=0;
			}
			
			GPR[20]=0x1;
			GPR[22]=0x0000003F;
			GPR[29]=0xa4001FFC;
			CP0[1]=0x0000001F;
			CP0[9]=1;
			CP0[12]=0x70400004;
			CP0[16]=0x00066463;
			WriteMemory(0x04300004, 1, hWndMain);
			WriteMemory(0x04300005, 1, hWndMain);
			WriteMemory(0x04300006, 1, hWndMain);
			WriteMemory(0x04300007, 1, hWndMain);
			PC=OldPC;
			break;
		}
		break;

	case WM_PAINT:
		if(DISPLAY_HEADER)
		{
			TextOut(hDC, 0, 0, byte_swapped, strlen(byte_swapped));
			TextOut(hDC, 0, 20, program_counter, strlen(program_counter));
			TextOut(hDC, 0, 40, ROMName, strlen(ROMName));
			strcpy(textt, "Manufacturer: ");
			strcat(textt, Manufacturer);
			TextOut(hDC, 0, 60, textt,strlen(textt));
			TextOut(hDC, 0, 80, Country,strlen(Country));
		}
		if(SHOW_IPS)
		{
					
			sprintf(space, "%8d instructions per second. ", ips);
			TextOut(hDC, 0, 0, space, strlen(space));
			
		}
		
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return(DefWindowProc(hWnd, uMsg, wParam, lParam));

	}
	return(0L);
}

LRESULT CALLBACK About(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		return (TRUE);
	case WM_COMMAND:
		if(LOWORD(wParam)==IDOK || LOWORD(wParam)==IDCANCEL)
		{
			EndDialog(hDlg,TRUE);
			return(TRUE);
		}
		break;
	}
	return (FALSE);
}

LRESULT CALLBACK ROM(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		ROMNameHandle=GetDlgItem(hDlg,IDC_ROMNAME);
		SendMessage(ROMNameHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)ROMName);
		ManufacturerHandle=GetDlgItem(hDlg,IDC_MANUFACTURER);
		SendMessage(ManufacturerHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)Manufacturer);
		return (TRUE);
	case WM_COMMAND:
		if(LOWORD(wParam)==IDOK || LOWORD(wParam)==IDCANCEL)
		{
			EndDialog(hDlg,TRUE);
			return(TRUE);
		}
		break;
	}
	return (FALSE);
}

LRESULT CALLBACK GPR_REGS(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		GPR0Handle=GetDlgItem(hDlg,IDC_GPR0);
		GPR1Handle=GetDlgItem(hDlg,IDC_GPR1);
		GPR2Handle=GetDlgItem(hDlg,IDC_GPR2);
		GPR3Handle=GetDlgItem(hDlg,IDC_GPR3);
		GPR4Handle=GetDlgItem(hDlg,IDC_GPR4);
		GPR5Handle=GetDlgItem(hDlg,IDC_GPR5);
		GPR6Handle=GetDlgItem(hDlg,IDC_GPR6);
		GPR7Handle=GetDlgItem(hDlg,IDC_GPR7);
		GPR8Handle=GetDlgItem(hDlg,IDC_GPR8);
		GPR9Handle=GetDlgItem(hDlg,IDC_GPR9);
		GPR10Handle=GetDlgItem(hDlg,IDC_GPR10);
		GPR11Handle=GetDlgItem(hDlg,IDC_GPR11);
		GPR12Handle=GetDlgItem(hDlg,IDC_GPR12);
		GPR13Handle=GetDlgItem(hDlg,IDC_GPR13);
		GPR14Handle=GetDlgItem(hDlg,IDC_GPR14);
		GPR15Handle=GetDlgItem(hDlg,IDC_GPR15);
		GPR16Handle=GetDlgItem(hDlg,IDC_GPR16);
		GPR17Handle=GetDlgItem(hDlg,IDC_GPR17);
		GPR18Handle=GetDlgItem(hDlg,IDC_GPR18);
		GPR19Handle=GetDlgItem(hDlg,IDC_GPR19);
		GPR20Handle=GetDlgItem(hDlg,IDC_GPR20);
		GPR21Handle=GetDlgItem(hDlg,IDC_GPR21);
		GPR22Handle=GetDlgItem(hDlg,IDC_GPR22);
		GPR23Handle=GetDlgItem(hDlg,IDC_GPR23);
		GPR24Handle=GetDlgItem(hDlg,IDC_GPR24);
		GPR25Handle=GetDlgItem(hDlg,IDC_GPR25);
		GPR26Handle=GetDlgItem(hDlg,IDC_GPR26);
		GPR27Handle=GetDlgItem(hDlg,IDC_GPR27);
		GPR28Handle=GetDlgItem(hDlg,IDC_GPR28);
		GPR29Handle=GetDlgItem(hDlg,IDC_GPR29);
		GPR30Handle=GetDlgItem(hDlg,IDC_GPR30);
		GPR31Handle=GetDlgItem(hDlg,IDC_GPR31);
		GPRPCHandle=GetDlgItem(hDlg,IDC_GPR_PC);
		GPROCHandle=GetDlgItem(hDlg,IDC_OPCODE);
		UpdateRegs();
		return (TRUE);
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case (IDOK || IDCANCEL):
			EndDialog(hDlg,TRUE);
			return(TRUE);
			break;
		case IDC_STEP:
			Step();
			debug.op=Instruction >> 26;
			debug.rs=(Instruction << 6) >> 27;
			debug.rt=(Instruction << 11) >> 27;
			debug.immediate=(Instruction << 16) >> 16;
			debug.target=(Instruction << 6) >> 6;
			debug.rd=(Instruction << 16) >> 27;
			debug.sa=(Instruction << 21) >> 28;
			debug.funct=(Instruction << 26) >> 26;
			debug.code=(Instruction << 6) << 12;
			debug.codea=(Instruction << 16)  >> 22;
			debug.codeb=(Instruction << 21) >> 21;
	strcpy(text, AddOp());
			UpdateRegs();
			break;
		}
		break;
	}
	return (FALSE);
}

LRESULT CALLBACK CP0_REGS(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		CP00Handle=GetDlgItem(hDlg,IDC_CP00);
		CP01Handle=GetDlgItem(hDlg,IDC_CP01);
		CP02Handle=GetDlgItem(hDlg,IDC_CP02);
		CP03Handle=GetDlgItem(hDlg,IDC_CP03);
		CP04Handle=GetDlgItem(hDlg,IDC_CP04);
		CP05Handle=GetDlgItem(hDlg,IDC_CP05);
		CP06Handle=GetDlgItem(hDlg,IDC_CP06);
		CP07Handle=GetDlgItem(hDlg,IDC_CP07);
		CP08Handle=GetDlgItem(hDlg,IDC_CP08);
		CP09Handle=GetDlgItem(hDlg,IDC_CP09);
		CP010Handle=GetDlgItem(hDlg,IDC_CP010);
		CP011Handle=GetDlgItem(hDlg,IDC_CP011);
		CP012Handle=GetDlgItem(hDlg,IDC_CP012);
		CP013Handle=GetDlgItem(hDlg,IDC_CP013);
		CP014Handle=GetDlgItem(hDlg,IDC_CP014);
		CP015Handle=GetDlgItem(hDlg,IDC_CP015);
		CP016Handle=GetDlgItem(hDlg,IDC_CP016);
		CP017Handle=GetDlgItem(hDlg,IDC_CP017);
		CP018Handle=GetDlgItem(hDlg,IDC_CP018);
		CP019Handle=GetDlgItem(hDlg,IDC_CP019);
		CP020Handle=GetDlgItem(hDlg,IDC_CP020);
		CP021Handle=GetDlgItem(hDlg,IDC_CP021);
		CP022Handle=GetDlgItem(hDlg,IDC_CP022);
		CP023Handle=GetDlgItem(hDlg,IDC_CP023);
		CP024Handle=GetDlgItem(hDlg,IDC_CP024);
		CP025Handle=GetDlgItem(hDlg,IDC_CP025);
		CP026Handle=GetDlgItem(hDlg,IDC_CP026);
		CP027Handle=GetDlgItem(hDlg,IDC_CP027);
		CP028Handle=GetDlgItem(hDlg,IDC_CP028);
		CP029Handle=GetDlgItem(hDlg,IDC_CP029);
		CP030Handle=GetDlgItem(hDlg,IDC_CP030);
		CP031Handle=GetDlgItem(hDlg,IDC_CP031);
		CP0PCHandle=GetDlgItem(hDlg,IDC_CP0_PC);
		UpdateRegs();
		return (TRUE);
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case (IDOK || IDCANCEL):
			EndDialog(hDlg,TRUE);
			return(TRUE);
			break;
		case IDC_STEP:
			Step();
			UpdateRegs();
			break;
		}
		break;
	}
	return (FALSE);
}

LRESULT CALLBACK FPR_REGS(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		FPR0Handle=GetDlgItem(hDlg,IDC_FPR0);
		FPR1Handle=GetDlgItem(hDlg,IDC_FPR1);
		FPR2Handle=GetDlgItem(hDlg,IDC_FPR2);
		FPR3Handle=GetDlgItem(hDlg,IDC_FPR3);
		FPR4Handle=GetDlgItem(hDlg,IDC_FPR4);
		FPR5Handle=GetDlgItem(hDlg,IDC_FPR5);
		FPR6Handle=GetDlgItem(hDlg,IDC_FPR6);
		FPR7Handle=GetDlgItem(hDlg,IDC_FPR7);
		FPR8Handle=GetDlgItem(hDlg,IDC_FPR8);
		FPR9Handle=GetDlgItem(hDlg,IDC_FPR9);
		FPR10Handle=GetDlgItem(hDlg,IDC_FPR10);
		FPR11Handle=GetDlgItem(hDlg,IDC_FPR11);
		FPR12Handle=GetDlgItem(hDlg,IDC_FPR12);
		FPR13Handle=GetDlgItem(hDlg,IDC_FPR13);
		FPR14Handle=GetDlgItem(hDlg,IDC_FPR14);
		FPR15Handle=GetDlgItem(hDlg,IDC_FPR15);
		FPR16Handle=GetDlgItem(hDlg,IDC_FPR16);
		FPR17Handle=GetDlgItem(hDlg,IDC_FPR17);
		FPR18Handle=GetDlgItem(hDlg,IDC_FPR18);
		FPR19Handle=GetDlgItem(hDlg,IDC_FPR19);
		FPR20Handle=GetDlgItem(hDlg,IDC_FPR20);
		FPR21Handle=GetDlgItem(hDlg,IDC_FPR21);
		FPR22Handle=GetDlgItem(hDlg,IDC_FPR22);
		FPR23Handle=GetDlgItem(hDlg,IDC_FPR23);
		FPR24Handle=GetDlgItem(hDlg,IDC_FPR24);
		FPR25Handle=GetDlgItem(hDlg,IDC_FPR25);
		FPR26Handle=GetDlgItem(hDlg,IDC_FPR26);
		FPR27Handle=GetDlgItem(hDlg,IDC_FPR27);
		FPR28Handle=GetDlgItem(hDlg,IDC_FPR28);
		FPR29Handle=GetDlgItem(hDlg,IDC_FPR29);
		FPR30Handle=GetDlgItem(hDlg,IDC_FPR30);
		FPR31Handle=GetDlgItem(hDlg,IDC_FPR31);
		FPRPCHandle=GetDlgItem(hDlg,IDC_FPR_PC);
		UpdateRegs();
		return (TRUE);
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case (IDOK || IDCANCEL):
			EndDialog(hDlg,TRUE);
			return(TRUE);
			break;
		case IDC_STEP:
			Step();
			UpdateRegs();
			break;
		}
		break;
	}
	return (FALSE);
}

LRESULT CALLBACK COMMANDS(HWND hDlg,
					   UINT message,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG:
		CommandsPCHandle=GetDlgItem(hDlg,IDC_COMMANDS_PC);
		//SCROLLINFO si;
		//int count, CenterPos;

		hCommandList   = GetDlgItem(hDlg,IDC_COMMANDS);
		hCommandScroll = GetDlgItem(hDlg,IDC_SCROLLBAR);

		UpdateCommands();
		
		return (TRUE);
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case (IDOK || IDCANCEL):
			EndDialog(hDlg,TRUE);
			return(TRUE);
			break;
		case IDC_ADD256:
			if(x>=dwSize-1024) return (FALSE);
			x=x+1024;
			UpdateCommands();
			return (TRUE);
		case IDC_SUB256:
			if(x+PC<=OldPC) return (FALSE);
			if(x<=1024)
			{
				x=0;
				UpdateCommands();
			
			}
			else
			{
			x=x-1024;
			UpdateCommands();
			}
			return (TRUE);
		case IDC_STEP:
			Step();
			UpdateCommandsPC();
		}
		break;
	}
	return (FALSE);
}

BOOL OpenRom(char szFileName[MAX_PATH])
{
	if(szFileName[0]=='\0') return FALSE;
	CloseHandle(RomHandle);
	RomHandle=CreateFile(szFileName, GENERIC_READ,
			0, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	strcpy(title, "Ultra 64 - ");
	strcat(title, szFileName);
	SetWindowText(hWndMain, title);
	ReadFile(RomHandle,two,2,&dwRead,NULL);
	byteswap=(two[0] << 8) + two[1];
			if(byteswap==0x8037)
			{
				BS=0;
				strcpy(byte_swapped, "Not Byteswapped.");
			}
			else
			{
				if(byteswap==0x3780)
				{
				BS=1;
				strcpy(byte_swapped, "Byteswapped.");
				}
				else
				{
					MessageBox(NULL, "Not a valid ROM!", "ROM", MB_OK);
					return FALSE;
				}
			}
			NOT_OPEN_ROM=FALSE;
			DISPLAY_HEADER=TRUE;
			hMenu = GetMenu(hWndMain);
	EnableMenuItem(hMenu, 
				   IDM_START, 
				   MFS_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(hMenu, 
				   IDM_PAUSE, 
				   MFS_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(hMenu, 
				   IDM_RESET, 
				   MFS_ENABLED | MF_BYCOMMAND);

	SetFilePointer(RomHandle,8,0,FILE_BEGIN);
	ReadFile(RomHandle,four,4,&dwRead,NULL);
	
	if(BS==1)
	{
	ROMPC=(four[1] << 24) + (four[0] << 16) + (four[3] << 8) + four[2];
	}
	else
	{
	ROMPC=(four[0] << 24) + (four[1] << 16) + (four[2] << 8) + four[3];
	}
	
	PC=0x04000040;
	OldPC=PC;
	sprintf(program_counter, "Program Counter: %x",PC);
	x=0;
	// Set registers to after PIF ROM values
	GPR[20]=0x1;
	GPR[22]=0x0000003F;
	GPR[29]=0xa4001FFC;
	CP0[1]=0x0000001F;
	CP0[9]=1;
	CP0[12]=0x70400004;
	CP0[16]=0x00066463;
	WriteMemory(0x04300004, 1, hWndMain);
	WriteMemory(0x04300005, 1, hWndMain);
	WriteMemory(0x04300006, 1, hWndMain);
	WriteMemory(0x04300007, 1, hWndMain);
	dwSize=GetFileSize(RomHandle, NULL);
	SetFilePointer(RomHandle,32,0,FILE_BEGIN);
	ReadFile(RomHandle,ROMName,20,&dwRead,NULL);
	if(BS) _swab( ROMName, ROMName, 20);
	if(BS)
	{
	SetFilePointer(RomHandle, 58, 0, FILE_BEGIN);
	}
	else
	{
		SetFilePointer(RomHandle,59,0,FILE_BEGIN);
	}

	ReadFile(RomHandle,four,1,&dwRead,NULL);
	ManufacturerCode = four	[0];
	switch(ManufacturerCode)
	{
	case 78:
		strcpy(Manufacturer, "Nintendo");
		break;
	default:
		sprintf(textt, "Unknown: %x",ManufacturerCode);
		strcat(Manufacturer, textt);
		break;
	}
	
	if(BS)
	{
	SetFilePointer(RomHandle, 63, 0, FILE_BEGIN);
	}
	else
	{
		SetFilePointer(RomHandle,62,0,FILE_BEGIN);
	}

	ReadFile(RomHandle,four,1,&dwRead,NULL);
	CountryCode = four	[0];
	strcpy(Country, "Country: ");
	switch(CountryCode)
	{
	case 0x44:
		strcat(Country, "Germany");
		break;
	case 0x45:
		strcat(Country, "USA");
		break;
	case 0x4A:
		strcat(Country, "Japan");
		break;
	case 0x50:
		strcat(Country, "Europe");
		break;
	case 0x55:
		strcat(Country, "Australia");
		break;
	default:
		sprintf(textt, "%x",CountryCode);
		strcat(Country, textt);
		break;
	}
	
	//Copy 0x1000 bytes to SP_DMEM
	for(z=0;z<4096;z=z+4)
	{
	SetFilePointer(RomHandle,(long)z,0,FILE_BEGIN);
	ReadFile(RomHandle,four,4,&dwRead,NULL);
	if(BS)
	{
	SP_DMEM[z]=four[1];
	SP_DMEM[z+1]=four[0];
	SP_DMEM[z+2]=four[3];
	SP_DMEM[z+3]=four[2];
	}
	else
	{
	SP_DMEM[z]=four[0];
	SP_DMEM[z+1]=four[1];
	SP_DMEM[z+2]=four[2];
	SP_DMEM[z+3]=four[3];
	}
	}
	return TRUE;
}

void UpdateRegs(void)
{
	//SendMessage(MemoryHandle,
	//			WM_SETTEXT, 0,
	//			(LPARAM)(LPCTSTR)(RAM[0]));
	
	SendMessage(GPROCHandle, WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[0]);
	SendMessage(GPR0Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[1]);
	SendMessage(GPR1Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[2]);
	SendMessage(GPR2Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[3]);
	SendMessage(GPR3Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[4]);
	SendMessage(GPR4Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[5]);
	SendMessage(GPR5Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[6]);
	SendMessage(GPR6Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[7]);
	SendMessage(GPR7Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[8]);
	SendMessage(GPR8Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[9]);
	SendMessage(GPR9Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[10]);
	SendMessage(GPR10Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[11]);
	SendMessage(GPR11Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[12]);
	SendMessage(GPR12Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[13]);
	SendMessage(GPR13Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[14]);
	SendMessage(GPR14Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[15]);
	SendMessage(GPR15Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[16]);
	SendMessage(GPR16Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[17]);
	SendMessage(GPR17Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[18]);
	SendMessage(GPR18Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[19]);
	SendMessage(GPR19Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[20]);
	SendMessage(GPR20Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[21]);
	SendMessage(GPR21Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[22]);
	SendMessage(GPR22Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[23]);
	SendMessage(GPR23Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[24]);
	SendMessage(GPR24Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[25]);
	SendMessage(GPR25Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[26]);
	SendMessage(GPR26Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[27]);
	SendMessage(GPR27Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[28]);
	SendMessage(GPR28Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[29]);
	SendMessage(GPR29Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[30]);
	SendMessage(GPR30Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", GPR[31]);
	SendMessage(GPR31Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", PC);
	SendMessage(GPRPCHandle,
				WM_SETTEXT, 0,
				(LPARAM)(LPCTSTR)text);
		sprintf(text, "%x", CP0[0]);
	SendMessage(CP00Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[1]);
	SendMessage(CP01Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[2]);
	SendMessage(CP02Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[3]);
	SendMessage(CP03Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[4]);
	SendMessage(CP04Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[5]);
	SendMessage(CP05Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[6]);
	SendMessage(CP06Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[7]);
	SendMessage(CP07Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[8]);
	SendMessage(CP08Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[9]);
	SendMessage(CP09Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[10]);
	SendMessage(CP010Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[11]);
	SendMessage(CP011Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[12]);
	SendMessage(CP012Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[13]);
	SendMessage(CP013Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[14]);
	SendMessage(CP014Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[15]);
	SendMessage(CP015Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[16]);
	SendMessage(CP016Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[17]);
	SendMessage(CP017Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[18]);
	SendMessage(CP018Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[19]);
	SendMessage(CP019Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[20]);
	SendMessage(CP020Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[21]);
	SendMessage(CP021Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[22]);
	SendMessage(CP022Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[23]);
	SendMessage(CP023Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[24]);
	SendMessage(CP024Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[25]);
	SendMessage(CP025Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[26]);
	SendMessage(CP026Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[27]);
	SendMessage(CP027Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[28]);
	SendMessage(CP028Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[29]);
	SendMessage(CP029Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[30]);
	SendMessage(CP030Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", CP0[31]);
	SendMessage(CP031Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", PC);
	SendMessage(CP0PCHandle,
				WM_SETTEXT, 0,
				(LPARAM)(LPCTSTR)text);
SendMessage(FPR0Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[1]);
	SendMessage(FPR1Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[2]);
	SendMessage(FPR2Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[3]);
	SendMessage(FPR3Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[4]);
	SendMessage(FPR4Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[5]);
	SendMessage(FPR5Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[6]);
	SendMessage(FPR6Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[7]);
	SendMessage(FPR7Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[8]);
	SendMessage(FPR8Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[9]);
	SendMessage(FPR9Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[10]);
	SendMessage(FPR10Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[11]);
	SendMessage(FPR11Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[12]);
	SendMessage(FPR12Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[13]);
	SendMessage(FPR13Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[14]);
	SendMessage(FPR14Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[15]);
	SendMessage(FPR15Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[16]);
	SendMessage(FPR16Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[17]);
	SendMessage(FPR17Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[18]);
	SendMessage(FPR18Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[19]);
	SendMessage(FPR19Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[20]);
	SendMessage(FPR20Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[21]);
	SendMessage(FPR21Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[22]);
	SendMessage(FPR22Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[23]);
	SendMessage(FPR23Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[24]);
	SendMessage(FPR24Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[25]);
	SendMessage(FPR25Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[26]);
	SendMessage(FPR26Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[27]);
	SendMessage(FPR27Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[28]);
	SendMessage(FPR28Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[29]);
	SendMessage(FPR29Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[30]);
	SendMessage(FPR30Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", FPR[31]);
	SendMessage(FPR31Handle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	sprintf(text, "%x", PC);
	SendMessage(FPRPCHandle,
				WM_SETTEXT, 0,
				(LPARAM)(LPCTSTR)text);
}

int Step(void)
{
if(Delay)
		{
		strcpy(OC, "Reading");
		four[0]=ReadMemory(DelayPC, hWndMain);
		four[1]=ReadMemory(DelayPC+1, hWndMain);
		four[2]=ReadMemory(DelayPC+2, hWndMain);
		four[3]=ReadMemory(DelayPC+3, hWndMain);
		Instruction=(four[0] <<24) + (four[1] << 16) +(four[2] <<8) +four[3];
		huh=Translate();		
		Delay=0;
		}
		else
		{
		strcpy(OC, "Reading");
		four[0]=ReadMemory(PC, hWndMain);
		four[1]=ReadMemory(PC+1, hWndMain);
		four[2]=ReadMemory(PC+2, hWndMain);
		four[3]=ReadMemory(PC+3, hWndMain);
			
		Instruction=(four[0] <<24) + (four[1] << 16) +(four[2] <<8) +four[3];
		huh=Translate();		
		}
		CP0[9]++;
		// Uncomment this to see name of current opcode
		/*
		strcpy(text, OC);
		MessageBox(hWndMain,text, "Opcode",MB_OK);
		*/
		if(SHOW)
		{
		sprintf(text,"%x",CP0[9]);
		strcpy(textt, lpszTitle);
		strcat(textt, "  ");
		strcat(textt,text);
		SetWindowText(hWndMain,textt);
		}
		
		if(huh==-1) 
		{
			if(STOP_OP)
			{
				strcpy(text,"Unhandled Opcode: ");
				strcat(text, OC);
				strcat(text, "\nEmulation stopped at instruction number ");
				sprintf(textt, "%d",CP0[9]+1);
				strcat(text,textt);
		 MessageBox(hWndMain,text, "Unhandled Opcode",MB_OK);
				return -1;
			}
			
		}
		return 0;
}